from abc import ABC

from asc.core import log
from asc.core import env_in_test, env_in_prod
from asc.core import session_factory, can_do_save


class ControlTool(ABC):

    def __init__(self):
        self.session = session_factory()

    def commit(self):
        """ Aplica commit quando não estiver estiver habilitado.
        :return: bool
        """
        log.info(f'CAN_DO_SAVE? {can_do_save}')
        log.info(f'env_in_test? {env_in_test}')
        log.info(f'env_in_prod? {env_in_prod}')
        if can_do_save:
            try:
                self.session.commit()
            except Exception as e:
                log.error(f'COMMIT ERROR {e}')
                self.session.rollback()
            return True
        return False

    def command_execute(self, attribute:str):
        """
        :param attribute: method name from abstract class
        :return: method
        """
        return getattr(self,attribute)

