from os import environ
from dotenv import load_dotenv, find_dotenv

load_dotenv(find_dotenv())

connection_engine = {
	"url": environ.get('database__engine',"postgresql+psycopg2://"),
	"max_overflow": environ.get('database__engine_max_overflow',50),
	"pool_size": environ.get('database__engine_pool_size',100),
	"pool_recycle": environ.get('database__engine_pool_recycle',400),
	"pool_timeout": environ.get('database__engine_pool_timeout',20),
	"pool_reset_on_return": "rollback",
    # https://docs.sqlalchemy.org/en/13/core/pooling.html#disconnect-handling-pessimistic
    "pool_pre_ping":True,
	'echo': environ.get('database__engine_echo',True)
}

connection_prefs = {
    'host': environ.get('database__host'),
    'port': environ.get('database__port'),
    'dbname': environ.get('database__dbname'),
    'user': environ.get('database__user'),
    'password': environ.get('database__password'),
    'connect_timeout': environ.get('database__connect_timeout'),
    'minconn': environ.get('database__minconn'),
    'maxconn': environ.get('database__maxconn')
}